/*! 
* WeX5 v3 (http://www.justep.com) 
* Copyright 2015 Justep, Inc.
* Licensed under Apache License, Version 2.0 (http://www.apache.org/licenses/LICENSE-2.0) 
*/ 
define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var Model = function() {
		this.callParent();
	};

	//数据刷新接管实现
	Model.prototype.masterDataCustomRefresh = function(event){
		/*
		event包含
			{
				"source" : 组件的js对象, 
				"cancel" : 可修改，设置为true后中断当前刷新动作, 
				"limit" : 页大小, 
				"offset" : 偏移,
				"options" : 刷新给入的参数
			}
		*/
		
		//这里简单演示从datas.json文件中取数据，还可以传递limit、offset实现分页的逻辑
		var masterData = event.source;
        $.ajax({
            type: "GET",
            url: require.toUrl('./datas.json'),
            dataType: 'json',
            async: false,//使用同步方式，目前data组件有同步依赖
            cache: false,
            success: function(data){
            	masterData.loadData(data);//将返回的数据加载到data组件
            },
            error: function(){
              throw justep.Error.create("加载数据失败");
            }
        });
	};

	//接管保存逻辑，这里将修改的数据送到服务端save.j，保存为save.json文件
	Model.prototype.masterDataCustomSave = function(event){
		/*
		event包含
			{
				"source" : 组件的js对象, 
				"cancel" : 可修改，设置为true后中断当前保存动作
				"options" : 保存时给入的参数
			}
		*/
		
		var masterData = event.source;
        $.ajax({
            type: "POST",
            url: require.toUrl('./save.j'),
            contentType: 'application/json',
            async: false,
            cache: false,
            data: JSON.stringify(masterData.toJson(true)),//序列化data修改的数据
            success: function(data){
            	masterData.applyUpdates();//更新数据状态
            },
            error: function(){
              throw justep.Error.create("保存数据失败");
            }
        });
	};

	//接管新增逻辑，简单使用new.json文件返回新增数据，还可以根据给入的默认值实现新增的数据默认值处理
	Model.prototype.masterDataCustomNew = function(event){
		/*
		event包含
			{
				"source" : 组件的js对象,
				"option" : 新增时传入的option参数，包括：parent,defaultValues
				"data" : 行数据对象数组[{sName:'LiMing',sAge:18},...]，数组的length决定新增的行数
					data格式：
						[
							{
								"列名" : 默认值,
								"列名" : 默认值,
								...
							},
							...
						]
			}
		*/

        $.ajax({
            type: "GET",
            url: require.toUrl('./new.json'),
            dataType: 'json',
            async: false,
            cache: false,
            success: function(data){
            	event.data = data;
            },
            error: function(){
              throw justep.Error.create("新增数据失败");
            }
        });
	};

	return Model;
});